# Python Client Scripts for Public RASP Shielding BE Endpoints

Sample REST API Client Scripts

## Description

These are client scripts that basically start a shielding process via public shielding APIs

Ensure to replace the required variables or inject them as environment variables as needed.

Install the required Python packages in the code.

Keep in mind that these are sample scripts just to show the usage of the APIs.
 
Adapt the code according to your environment and own needs.

## Configuration and Endpoints Usage

* Ensure you have already installed Python3
    - $ python3 --version

* Provide the required environment variables in the '.env' file (hidden file)

* Under the parent folder location, execute de following commands:
    - $ python3 -m venv shieldingapps_venv
    * **macOS/Linux**:
        - $ source shieldingapps_venv/bin/activate
    * **Windows**:        
        - $ shieldingapps_venv\Scripts\activate    
    - $ pip3 install -r requirements.txt

* Working with the Endpoints:
    + Start Shielding App:
        - You must have the Configuration Key UUID, Platform and the Mobile file name before starting.
        - $ python3 start_shielding_app.py --configurationKey <CONFIG_KEY_UUID> --shielderPlatform <MOBILE_OS_PLATFORM> --fileNameWithExt <MOBILE_APP_FILENAME>
        - Sample:
            - python3 start_shielding_app.py --configurationKey 0ef41a59-1234-abcd-a208-7368f514d0d5 --shielderPlatform ANDROID --fileNameWithExt Mobile_Sample_App_6.5.3.apk
        - The SHIELDING_UUID obtained here must be the input for the next scripts
        - 'Mobile_Sample_App_6.5.3.apk' is just and Android sample app. You have to replace it by the one you want to shield.

    + Shielding Progress Details:
        - You must have the SHIELDING_UUID obtained in the step 1.
        - $ python3 get_shielding_progress.py --shieldingUUID <SHIELDING_UUID>
        - Sample:
            - $ python3 get_shielding_progress.py --shieldingUUID 748f2f13-7967-dcba-4321-53946292ba85

    + Downloading Shielded App:
        - You must have the SHIELDING_UUID obtained in the step 1.
        - $ python3 download_shielded_app.py --shieldingUUID <SHIELDING_UUID>
        - Sample:
            - $ python3 download_shielded_app.py --shieldingUUID 748f2f13-7967-4bbd-803a-53946292ba85

* Once working with endpoints has finished:
    - $ deactivate
    